// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Zyltimer.pas' rev: 10.00

#ifndef ZyltimerHPP
#define ZyltimerHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zyltimer
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TZylTimer;
class PASCALIMPLEMENTATION TZylTimer : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FRegistered;
	double FVersion;
	double FInterval;
	Classes::TNotifyEvent FOnTimer;
	bool FEnabled;
	Classes::TThread* FTimerThread;
	bool FCycled;
	unsigned FRepeatCount;
	unsigned FCounter;
	Classes::TThreadPriority FPriority;
	bool FNeedSynchronization;
	void __fastcall SetEnabled(bool Value);
	void __fastcall SetInterval(double Value);
	void __fastcall SetPriority(Classes::TThreadPriority Value);
	void __fastcall SetOnTimer(Classes::TNotifyEvent Value);
	bool __fastcall RunningInTheIDE(void);
	void __fastcall DoTimer(void);
	
public:
	__property bool NeedSynchronization = {read=FNeedSynchronization, write=FNeedSynchronization, default=0};
	__property double Version = {read=FVersion};
	__fastcall virtual TZylTimer(Classes::TComponent* AOwner);
	__fastcall virtual ~TZylTimer(void);
	unsigned __fastcall GetCycleNumber(void);
	void __fastcall Start(void);
	void __fastcall Restart(void);
	void __fastcall Stop(void);
	
protected:
	void __fastcall UpdateTimer(void);
	
__published:
	__property bool Enabled = {read=FEnabled, write=SetEnabled, default=1};
	__property double Interval = {read=FInterval, write=SetInterval};
	__property bool Cycled = {read=FCycled, write=FCycled, default=1};
	__property unsigned RepeatCount = {read=FRepeatCount, write=FRepeatCount, default=0};
	__property Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=SetOnTimer};
	__property Classes::TThreadPriority Priority = {read=FPriority, write=SetPriority, default=3};
};


class DELPHICLASS TTimerThread;
class PASCALIMPLEMENTATION TTimerThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	TZylTimer* Owner;
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall CustomSleep(unsigned Interval);
	
public:
	__fastcall TTimerThread(TZylTimer* AOwner);
	__fastcall virtual ~TTimerThread(void);
};


struct TTimeCaps
{
	
public:
	unsigned wPeriodMin;
	unsigned wPeriodMax;
} ;

typedef TTimeCaps *PTimeCaps;

//-- var, const, procedure ---------------------------------------------------
static const int MAX_UINT = 0x7fffffff;
static const unsigned MAX_CARDINAL = 0xffffffff;
static const Word TIMER_RESOLUTION = 0x3e8;
extern PACKAGE unsigned __stdcall (*_timeBeginPeriod)(unsigned period);
extern PACKAGE unsigned __stdcall (*_timeEndPeriod)(unsigned period);
extern PACKAGE unsigned __stdcall (*_timeGetDevCaps)(PTimeCaps lpTimeCaps, unsigned uSize);
extern PACKAGE void * __fastcall LinkAPI(const AnsiString module, const AnsiString functionname);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Zyltimer */
using namespace Zyltimer;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Zyltimer
